﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;

namespace SampleUltraGrid
{
    public partial class CellInfoControl : UserControl
    {
        public CellInfoControl()
        {
            InitializeComponent();
        }

        private void CellInfoControl_Load(object sender, EventArgs e)
        {
            this.ultraButton1.Appearance.Image = ImageServer.GetImage("History");
            this.ultraButton1.Text = string.Empty;
        }

        public string Value
        {
            get
            {
                // In theory, you need to rebuild the string from the labels and buttons here. But since the cell is not editable, 
                // you might be able to just do nothing here. 
                return this.ultraLabel1.Text + " " +  this.ultraLabel2.Text;
            }
            set
            {
                string mytemp = string.Empty;
                string strrValue = value;
                string strrValOnly = string.Empty;
                string strRefRangeWithUnit = string.Empty;
                this.ultraLabel2.Text = string.Empty;
                int foundRefRangeUnit = strrValue.IndexOf("\n");
                if (foundRefRangeUnit > 0)
                {
                    //it means unit ref range string is present so format it with 7 font size
                    strRefRangeWithUnit = strrValue.Substring(foundRefRangeUnit + "\n".Length);
                    if (!string.IsNullOrEmpty(strRefRangeWithUnit))
                    {                        
                        this.ultraLabel2.Text = strRefRangeWithUnit;
                        strrValOnly = strrValue.Substring(0, foundRefRangeUnit);
                        this.ultraLabel1.Text = strrValOnly;
                    }
                }

                // In your original code, the arrows where shown based on the cell Index, but you can't do that here. It has to be based on something in the 
                // actual value of the cell, because that's all the editor has. 
                bool showArrows = false;                
                int x;
                if (int.TryParse(strrValOnly, out x))
                    showArrows = (x % 2) == 0;
                    
                if (showArrows)
                    this.ultraPictureBox1.Image = ImageServer.GetImage("Task");
                else
                    this.ultraPictureBox1.Image = null;
            }

        }
                
        protected override void SetBoundsCore(int x, int y, int width, int height, BoundsSpecified specified)
        {
            var buttonPreferredSize = this.ultraButton1.PreferredSize;
            this.ultraButton1.SetBounds(
                width - buttonPreferredSize.Width,
                0,
                buttonPreferredSize.Width,
                buttonPreferredSize.Height
                );

            var pictureBoxPreferredSize = this.ultraPictureBox1.PreferredSize;
            this.ultraPictureBox1.SetBounds(
                this.ultraButton1.Left - pictureBoxPreferredSize.Width,
                0,
                pictureBoxPreferredSize.Width,
                pictureBoxPreferredSize.Height
                );

            base.SetBoundsCore(x, y, width, height, specified);
        }

        public event EventHandler ButtonClick;

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            if (null != this.ButtonClick)
                this.ButtonClick(this, EventArgs.Empty);
        }
    }
}
