﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Infragistics.Win;
using Infragistics.Win.FormattedLinkLabel;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace SampleUltraGrid
{
    public partial class Form1 : Form
    {
        private ControlContainerEditor controlContainerEditor;
       
        public Form1()
        {
            InitializeComponent();
            this.controlContainerEditor = new ControlContainerEditor();
            var renderingControl = new CellInfoControl();
            renderingControl.Name = "RenderingControl";
            this.controlContainerEditor.RenderingControl = renderingControl;
            this.controlContainerEditor.RenderingControlPropertyName = "Value";

            var editingControl = new CellInfoControl();
            editingControl.Name = "EditingControl";
            this.controlContainerEditor.EditingControl = editingControl;
            editingControl.ButtonClick += this.EditingControl_ButtonClick;
            this.controlContainerEditor.EditingControlPropertyName = "Value";
            this.controlContainerEditor.EnterEditModeMouseBehavior = EnterEditModeMouseBehavior.EnterEditModeAndClick;
        }

        private void EditingControl_ButtonClick(object sender, EventArgs e)
        {
            var activeCell = this.ultraGrid1.ActiveCell;
            var cellString = string.Format("{0}, {1}", activeCell.Column.Index, activeCell.Row.Index);
            MessageBox.Show(string.Format("Button clicked for {0}", cellString));
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            foreach (var column in e.Layout.Bands[0].Columns)
            {
                switch (column.Key)
                {
                    case "Column 0":
                        continue;
                    case "Column 1":
                        column.Editor = this.controlContainerEditor;
                        break;
                    default:
                        //column.Hidden = true;
                        column.Editor = this.controlContainerEditor;
                        break;
                }
            }
        }

        private void uRGrid_InitializeRow(object sender, InitializeRowEventArgs e)
        {
        }
        internal static string GetImageTag(Image image)
        {
            return string.Format("<img align=\"top|right\" style=\"width:{0}px; height:{1}px;\" data=\"{2}\"/>",
                image.Width,
                image.Height,
                Infragistics.Win.FormattedLinkLabel.FormattedLinkEditor.EncodeImage(image));
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
